﻿@page "/stadiums"
@using Models.StadiumData
@using Business.Repository.IRepository
@inject IStadiumRepository StadiumRepository
@inject IJSRuntime JsRuntime
@inject NavigationManager NavigationManager

<div class="row mt-4">
    <div class="col-8">
        <h4 class="card-title text-info">Stadiums</h4>
    </div>
    <div class="col-3 offset-1">
        <NavLink href="stadiums/create" class="btn btn-primary form-control">Add new stadium</NavLink>
    </div>
</div>
<div class="row mt-4">
    <div class="col-12">
        <table class="table table-bordered table-hover">
            <thead>
                <tr>
                    <th width="35%" class="text-center">Name</th>
                    <th width="30%" class="text-center">Address</th>
                    <th width="10%">
                        Actions
                    </th>
                </tr>
            </thead>
            <tbody>
                @if (Stadiums.Any())
                {
                    foreach (var stadium in Stadiums)
                    {
                        <tr>
                            <td class="text-center">@stadium.Name</td>
                            <td class="text-center">@stadium.Address</td>
                            <td>
                                <NavLink href="@($"stadiums/edit/{stadium.Id}")" class="btn btn-primary">Edit</NavLink>
                                <button class="btn btn-danger" @onclick="()=>HandleDelete(stadium.Id)">Delete</button>
                            </td>
                        </tr>
                    }
                }
                else
                {
                    <tr>
                        <td colspan="5">No records found</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>

<DeleteConfirmation IsParentComponentProcessing="IsProcessing" ConfirmationChanged="ConfirmDelete_Click"></DeleteConfirmation>

@code {
    private IEnumerable<StadiumDTO> Stadiums { get; set; } = new List<StadiumDTO>();
    private int? DeleteStadiumId { get; set; } = null;
    private bool IsProcessing { get; set; } = false;

    protected async override Task OnInitializedAsync()
    {
        Stadiums = await StadiumRepository.GetAll();
    }

    private async Task HandleDelete(int stadiumId)
    {
        DeleteStadiumId = stadiumId;
        await JsRuntime.InvokeVoidAsync("ShowDeleteConfirmationModal");
    }
    public async Task ConfirmDelete_Click(bool isConfirmed)
    {
        IsProcessing = true;
        if (isConfirmed && DeleteStadiumId != null)
        {
            var result = await StadiumRepository.Delete(DeleteStadiumId.Value);
            if(result == 0)
            {
                await JsRuntime.ToastrError("Stadium is used and cannot be deleted!");
            }
            else
            {
                await JsRuntime.ToastrSuccess("Stadium successfully deleted!");
                Stadiums = await StadiumRepository.GetAll();
            }
        }
        await JsRuntime.InvokeVoidAsync("HideDeleteConfirmationModal");
        IsProcessing = false;
    }
}
